Status: Closed Priority: Must have
Author: Bastian Waidelich Category: Reflection
Created: 2014-05-22 Assigned To: Bastian Waidelich
Updated: 2014-11-27 Due date:
PHP Version:
Has patch: No
Complexity:
Affected Flow version: (any)
Subject: Broken Reflection behavior on class-/filename mismatch
Description
When a PHP class is not named exactly like the corresponding file, weird things happen:
    -  If only the case doesn't match (e.g. "someclass" vs "SomeClass") the class is reflected but weird side effects happen during
"runtime" 
    -  If the class name is different (e.g. "SomeClass" vs "SomeRenamedClass") the ReflectionService currently "silently" skips the
class

Depending on what class is affected this can lead to a "Cannot redeclare class" error:

#1355480641:
Fatal error: Cannot redeclare class Some\Package\Domain\Model\SomeEntity in
Packages/Application/Some.Package/Classes/Some/Package/Domain/Model/RenamedEntity.php on line xx

Associated revisions
Revision b2653fda - 2014-05-22 14:47 - Christian Müller

[BUGFIX] Throw exception if case of class- and filename don't match

Mismatching class- and filename case is now detected during compiletime
already and a helpful exception is thrown.

Change-Id: Id3f5b1d4f151a5e1acb6624ffbbad9ad0bca22cf
Related: #59031
Releases: master, 2.2, 2.1

Revision e29e6995 - 2014-05-26 20:22 - Christian Müller

[BUGFIX] Throw exception if case of class- and filename don't match

Mismatching class- and filename case is now detected during compiletime
already and a helpful exception is thrown.

Change-Id: Id3f5b1d4f151a5e1acb6624ffbbad9ad0bca22cf
Related: #59031
Releases: master, 2.2, 2.1
Revision 9408eb09 - 2014-06-18 22:32 - Christian Müller

[BUGFIX] Throw exception if case of class- and filename don't match

Mismatching class- and filename case is now detected during compiletime
already and a helpful exception is thrown.

Change-Id: Id3f5b1d4f151a5e1acb6624ffbbad9ad0bca22cf
Related: #59031
Releases: master, 2.2, 2.1

History
#1 - 2014-05-22 14:58 - Bastian Waidelich
- File 59031_cli.png added
- File 59031_web.png added

Fix of the ReflectionService leads to following exception:
CLI:
59031_cli.png

Web:
59031_web.png

#2 - 2014-05-22 16:26 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at https://review.typo3.org/30332

#3 - 2014-08-25 19:02 - Gerrit Code Review

Patch set 2 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/30332

#4 - 2014-08-27 12:16 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.Flow has been pushed to the review server.
It is available at http://review.typo3.org/30332

#5 - 2014-11-27 10:36 - Bastian Waidelich
- Status changed from Under Review to Closed

Issue has been moved to https://jira.typo3.org/browse/FLOW-128
